﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamTreeGridCheckboxCommandingCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        public MyCheckEditorCommand MyCommand { get; set; }

        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();
            MyCommand = new MyCheckEditorCommand();

            for (int i = 0; i < 12; i++)
            {
                if (i % 3 == 0)
                {
                    Data.Add(new SampleData()
                    {
                        ID = i,
                        IsChecked = true
                    });
                }
                else if (i % 3 == 1)
                {
                    Data.Add(new SampleData()
                    {
                        ID = i,
                        IsChecked = false
                    });
                }
                else
                {
                    Data.Add(new SampleData()
                    {
                        ID = i,
                        IsChecked = null
                    });
                }
            }
        }
    }

    public class SampleData : INotifyPropertyChanged
    {
        private bool? _ic;
        private int id;

        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }

        public bool? IsChecked
        {
            get { return _ic; }
            set
            {
                if (_ic != value)
                {
                    _ic = value;
                    OnPropertyChanged("IsChecked");
                }
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
